%close all
%clear all
%clc

u_GSMr = 5.6;
M_extr = 0;

L_GSM=1.4e-3;
R_GSM=0.46;
k_GSM=0.1;
J_GSM=12.4e-3;
d_cGSM=0.152;
d_vGSM=1.8e-3;
J_P=32.5e-3;
d_cP=0.169;
d_vP=2.7e-3;
d_qP=1e-4;
c_GSMP=0.6822;
d_GSMP=1e-5;


%Ruhelagen:
%1 = 75.8666
%i_GSMr = (u_GSMr + (k_GSM*(R_GSM*d_vP + R_GSM*d_vGSM + (k_GSM^4 + R_GSM^2*d_vP^2 + R_GSM^2*d_vGSM^2 - 4*M_extr*R_GSM^2*d_qP - 4*R_GSM^2*d_cP*d_qP - 4*R_GSM^2*d_cGSM*d_qP + 2*R_GSM^2*d_vP*d_vGSM + 2*R_GSM*d_vP*k_GSM^2 + 2*R_GSM*d_vGSM*k_GSM^2 + 4*R_GSM*d_qP*k_GSM*u_GSMr)^(1/2) + k_GSM^2))/(2*R_GSM*d_qP))/R_GSM 
%2 = 5.5228
i_GSMr = (u_GSMr + (k_GSM*(R_GSM*d_vP + R_GSM*d_vGSM - (k_GSM^4 + R_GSM^2*d_vP^2 + R_GSM^2*d_vGSM^2 - 4*M_extr*R_GSM^2*d_qP - 4*R_GSM^2*d_cP*d_qP - 4*R_GSM^2*d_cGSM*d_qP + 2*R_GSM^2*d_vP*d_vGSM + 2*R_GSM*d_vP*k_GSM^2 + 2*R_GSM*d_vGSM*k_GSM^2 + 4*R_GSM*d_qP*k_GSM*u_GSMr)^(1/2) + k_GSM^2))/(2*R_GSM*d_qP))/R_GSM

%1 = 11.6711
%phi_GSMPr = ((k_GSM^2 + R_GSM*d_vGSM)*(R_GSM*d_vP + R_GSM*d_vGSM + (k_GSM^4 + R_GSM^2*d_vP^2 + R_GSM^2*d_vGSM^2 - 4*M_extr*R_GSM^2*d_qP - 4*R_GSM^2*d_cP*d_qP - 4*R_GSM^2*d_cGSM*d_qP + 2*R_GSM^2*d_vP*d_vGSM + 2*R_GSM*d_vP*k_GSM^2 + 2*R_GSM*d_vGSM*k_GSM^2 + 4*R_GSM*d_qP*k_GSM*u_GSMr)^(1/2) + k_GSM^2))/(2*R_GSM^2*c_GSMP*d_qP) - (R_GSM*d_cGSM - k_GSM*u_GSMr)/(R_GSM*c_GSMP)
%2 = 0.5060
phi_GSMPr = ((k_GSM^2 + R_GSM*d_vGSM)*(R_GSM*d_vP + R_GSM*d_vGSM - (k_GSM^4 + R_GSM^2*d_vP^2 + R_GSM^2*d_vGSM^2 - 4*M_extr*R_GSM^2*d_qP - 4*R_GSM^2*d_cP*d_qP - 4*R_GSM^2*d_cGSM*d_qP + 2*R_GSM^2*d_vP*d_vGSM + 2*R_GSM*d_vP*k_GSM^2 + 2*R_GSM*d_vGSM*k_GSM^2 + 4*R_GSM*d_qP*k_GSM*u_GSMr)^(1/2) + k_GSM^2))/(2*R_GSM^2*c_GSMP*d_qP) - (R_GSM*d_cGSM - k_GSM*u_GSMr)/(R_GSM*c_GSMP)

%1 = -292.9863
%w_GSMr = -(R_GSM*d_vP + R_GSM*d_vGSM + (k_GSM^4 + R_GSM^2*d_vP^2 + R_GSM^2*d_vGSM^2 - 4*M_extr*R_GSM^2*d_qP - 4*R_GSM^2*d_cP*d_qP - 4*R_GSM^2*d_cGSM*d_qP + 2*R_GSM^2*d_vP*d_vGSM + 2*R_GSM*d_vP*k_GSM^2 + 2*R_GSM*d_vGSM*k_GSM^2 + 4*R_GSM*d_qP*k_GSM*u_GSMr)^(1/2) + k_GSM^2)/(2*R_GSM*d_qP)
%2 = 30.5950
w_GSMr = -(R_GSM*d_vP + R_GSM*d_vGSM - (k_GSM^4 + R_GSM^2*d_vP^2 + R_GSM^2*d_vGSM^2 - 4*M_extr*R_GSM^2*d_qP - 4*R_GSM^2*d_cP*d_qP - 4*R_GSM^2*d_cGSM*d_qP + 2*R_GSM^2*d_vP*d_vGSM + 2*R_GSM*d_vP*k_GSM^2 + 2*R_GSM*d_vGSM*k_GSM^2 + 4*R_GSM*d_qP*k_GSM*u_GSMr)^(1/2) + k_GSM^2)/(2*R_GSM*d_qP)

%1 = -292.9863
%w_Pr = -(R_GSM*d_vP + R_GSM*d_vGSM + (k_GSM^4 + R_GSM^2*d_vP^2 + R_GSM^2*d_vGSM^2 - 4*M_extr*R_GSM^2*d_qP - 4*R_GSM^2*d_cP*d_qP - 4*R_GSM^2*d_cGSM*d_qP + 2*R_GSM^2*d_vP*d_vGSM + 2*R_GSM*d_vP*k_GSM^2 + 2*R_GSM*d_vGSM*k_GSM^2 + 4*R_GSM*d_qP*k_GSM*u_GSMr)^(1/2) + k_GSM^2)/(2*R_GSM*d_qP)
%2 = 30.5950
w_Pr = -(R_GSM*d_vP + R_GSM*d_vGSM - (k_GSM^4 + R_GSM^2*d_vP^2 + R_GSM^2*d_vGSM^2 - 4*M_extr*R_GSM^2*d_qP - 4*R_GSM^2*d_cP*d_qP - 4*R_GSM^2*d_cGSM*d_qP + 2*R_GSM^2*d_vP*d_vGSM + 2*R_GSM*d_vP*k_GSM^2 + 2*R_GSM*d_vGSM*k_GSM^2 + 4*R_GSM*d_qP*k_GSM*u_GSMr)^(1/2) + k_GSM^2)/(2*R_GSM*d_qP)

x0 = [i_GSMr;phi_GSMPr;w_GSMr;w_Pr];
x0_r = [phi_GSMPr;w_GSMr;w_Pr];

%Linearisiertes System vollstaendig
A_v = [  -R_GSM/L_GSM,             0,             -k_GSM/L_GSM,                                                                                                                                                                                                                                                                                                0;...
                    0,             0,                        1,                                                                                                                                                                                                                                                                                               -1;...
          k_GSM/J_GSM, -c_GSMP/J_GSM, -(d_GSMP + d_vGSM)/J_GSM,                                                                                                                                                                                                                                                                                     d_GSMP/J_GSM;...
                    0,    c_GSMP/J_P,               d_GSMP/J_P, -(d_GSMP + d_vP - (R_GSM*d_vP + R_GSM*d_vGSM - (k_GSM^4 + R_GSM^2*d_vP^2 + R_GSM^2*d_vGSM^2 - 4*M_extr*R_GSM^2*d_qP - 4*R_GSM^2*d_cP*d_qP - 4*R_GSM^2*d_cGSM*d_qP + 2*R_GSM^2*d_vP*d_vGSM + 2*R_GSM*d_vP*k_GSM^2 + 2*R_GSM*d_vGSM*k_GSM^2 + 4*R_GSM*d_qP*k_GSM*u_GSMr)^(1/2) + k_GSM^2)/R_GSM)/J_P];
B_v =  [1/L_GSM,     0;...
              0,     0;...
              0,     0;...
              0,-1/J_P];
C_v = eye(4);
D_v = [0,0;0,0;0,0;0,0];

%Linearisiertes System reduziert
A_r = [             0,                                        1,                                                                                                                                                                                                                                                                                               -1;...
        -c_GSMP/J_GSM, -(k_GSM^2/R_GSM + d_GSMP + d_vGSM)/J_GSM,                                                                                                                                                                                                                                                                                     d_GSMP/J_GSM;...
           c_GSMP/J_P,                               d_GSMP/J_P, -(d_GSMP + d_vP - (R_GSM*d_vP + R_GSM*d_vGSM - (k_GSM^4 + R_GSM^2*d_vP^2 + R_GSM^2*d_vGSM^2 - 4*M_extr*R_GSM^2*d_qP - 4*R_GSM^2*d_cP*d_qP - 4*R_GSM^2*d_cGSM*d_qP + 2*R_GSM^2*d_vP*d_vGSM + 2*R_GSM*d_vP*k_GSM^2 + 2*R_GSM*d_vGSM*k_GSM^2 + 4*R_GSM*d_qP*k_GSM*u_GSMr)^(1/2) + k_GSM^2)/R_GSM)/J_P];
B_r =  [                 0,     0;...
       k_GSM/(J_GSM*R_GSM),     0;...
                         0,-1/J_P];
C_r = eye(3);
D_r = [0,0;0,0;0,0]; 