p1 = [1 8 19 12]
A = [-1, 2; -2, -6]
p2 = poly(A)

p3 = conv(p1, p2)


p4 = polydiff(p1)
p5 = polydiff(p2)
p6 = polydiff(p3)

findzero(p3, 0) % = -1
findzero(p3, -1.5) % = -2
findzero(p3, -2.5) % = -5
findzero(p3, -2.9) % = -3
findzero(p3, -4.5) % = -4
findzero(p3, -3.5) % = -1

x = -3:0.001:0;
plot(x,polyval(p3,x));

roots(p3)

function pd = polydiff(p)
    pd = zeros(1,length(p)-1);
    for i=1:length(pd)
        pd(i) = p(i) * (length(p)-i);
    end
end

function s0 = findzero(p,sstart)
    s0 = sstart;
    pd = polydiff(p);
    while abs(polyval(p,s0)) > 1e-2
        s0 = s0 - polyval(p,s0)/polyval(pd,s0);
    end
end